#ifndef STRATEGY_PP
#define STRATEGY_PP

#include "strategy.h"

class StrategyPP : public Strategy { //zmente jmeno tridy 
public:

	int L;
	int Pamet[10];

	void reward(int _reward)
	{
		if (L <= 3) L++;
		for(int i=L-2; i>=0; i--)
			Pamet[i+1]=Pamet[i];
		
		Pamet[0] = _reward;
	};

	void reset() {
		L = 0;
	}		

	StrategyPP()
	{ 
		reset();
        }  

	virtual int operator()() { 

	int sum = 0;
	for(int i=0; i<L; i++)
		if ((Pamet[i] == CC) || (Pamet[i] == DC)) sum++; else sum--;
    
	if (L == 0) return COOPERATE;
	
	// prave me zradil
	if ((Pamet[0] == CD)||(Pamet[0] == DD)) return DECEIVE; 

	// ja jsem ho zradil, ale on ne a navic mi casteji pomohl
	if ((Pamet[0] == DC) && (sum > 0)) return COOPERATE;

	// nezradili jsme se:

	if (L == 1) return COOPERATE;

	// zradil me minule
	if ((Pamet[1] == CD)||(Pamet[1] == DD)) return DECEIVE;

	// nezradil me ted ani minule, ale ja ho zradil minule
	if (Pamet[1] == DC) return COOPERATE; 

	// nezradili jsme se uz po dva tahy, rozhoduje suma:
	if (sum > 0) return COOPERATE;
	
	return DECEIVE;
  } 

  virtual string getName() { return "Strategie_PP"; }  // pojmenujte si ji  
}; 


#endif

